package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.*;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class IsSubformula {

	private String strPhi;
	private String strCtf;	
	private boolean expected;
	
	public IsSubformula(String formula1, String formula2, boolean expected) {
		this.strPhi = formula1;
		this.strCtf = formula2;
		this.expected = expected;
	}

	@Parameters
	public static Collection<Object[]> data() {
		Object[][] data = new Object[][] {
				{ "a | F (a | c)", "a", true },
				{ "a | F (a | c)", "a | c", true },
				{ "a | F (a | c)", "a | b", false },
		};
		return Arrays.asList(data);
	}

	@Test
	public void pushTest() {
		System.out.println("\n"+this.getClass().getCanonicalName());
		
		LTLParser parser = new LTLParser(new StringReader(strPhi));
		Formula phi = null;
		try { phi = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		parser.ReInit(new StringReader(strCtf));
		Formula ctf = null;
		try { ctf = parser.parsePreviousAtoms(); }
		catch (Exception e) { assertTrue(false); }
		
		System.out.println("phi     : "+phi);
		System.out.println("ctf     : "+ctf);
		System.out.println("expected: "+expected);
		assertTrue(phi.hasSubformula(ctf) == expected);
	}
}
